clc
clear

a=5;b=4; % linear regression
NN = 1000; %number of samples
MM = 100; %number of sampling
alpha = 0.75; %percent of the tail
k = 0.1; sigm = 0.7; %parameters of GPD

mua_real =  sigm/(1-k); 
kappa_real = 1/(1+k); 

table_report=[];
for ii=1:MM
disp(ii)
rng(ii)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%%%%% Create artificial data    
workdata1 = sort(rand(1,NN));
errors_main = randn(1,NN);
quant1 = quantile(errors_main,alpha);
errors_main_new = errors_main(errors_main<quant1);

errors_tail = gprnd(k,sigm,0,1,NN - size(errors_main_new,2));

errors = [errors_main_new,errors_tail+quant1];
rp = randperm(NN);
errors = errors(rp);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Estimation
params = tsallis_harmonik_params_loss(errors_tail);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% save results
table_report(ii).mua = [mua_real;params(1).mua;params(2).mua];
table_report(ii).kappa = [kappa_real;params(1).kappa;params(2).kappa];
table_report(ii).const = params(1).const;
end

%%%% RE
RE1_mua=[];RE2_mua=[]; RE1_kappa=[];RE2_kappa=[];
for ik=1:size(table_report,2)
   RE1_mua = [RE1_mua,(table_report(ik).mua(1)-table_report(ik).mua(2))/table_report(ik).mua(1)];   
   RE1_kappa = [RE1_kappa,(table_report(ik).kappa(1)-table_report(ik).kappa(2))/table_report(ik).kappa(1)];   
   if table_report(ik).kappa(3)~=0
    RE2_kappa = [RE2_kappa,(table_report(ik).kappa(1)-table_report(ik).kappa(3))/table_report(ik).kappa(1)];
   end
end

stat1_mua = 100*[min(RE1_mua),mean(RE1_mua),max(RE1_mua)];
stat1_kappa = 100*[min(RE1_kappa),mean(RE1_kappa),max(RE1_kappa)];
stat2_kappa = 100*[min(RE2_kappa),mean(RE2_kappa),max(RE2_kappa)];

table_rep_full = [stat1_mua;stat1_kappa;stat2_kappa]; %main report of RE

fid = fopen(sprintf('report_GPD_tail_%d.csv',NN*(1-alpha)),'w');
fprintf(fid,'method, sampe size, parameter , min %%, mean %%, max %%, deviation %% \n');
fprintf(fid,' ,%d,mua, %f, %f, %f, %f\n',NN*(1-alpha),stat1_mua(1),stat1_mua(2),stat1_mua(3),stat1_mua(3)-stat1_mua(1));
fprintf(fid,'ML ,%d,kappa, %f, %f, %f, %f\n',NN*(1-alpha),stat1_kappa(1),stat1_kappa(2),stat1_kappa(3),stat1_kappa(3)-stat1_kappa(1));
fprintf(fid,'harmonic ,%d,kappa, %f, %f, %f, %f\n',NN*(1-alpha),stat2_kappa(1),stat2_kappa(2),stat2_kappa(3),stat2_kappa(3)-stat2_kappa(1));
fclose(fid)

